#!/bin/bash

DIR_IMAGE=${1%\/}

. $(dirname $0)/functions.sh

DIALOG+=( --title "Redenominación de ${DIR_IMAGE##*/}" )

mensaje_error="No se ha cambiado el nombre a ${DIR_IMAGE##*\/}."

output=$(mktemp)
trap "rm -f $output" SIGHUP SIGINT SIGKILL SIGTERM
trap "salida \$? \"\$mensaje_exito\" \"\$mensaje_error\"; rm -f \$output" EXIT

"${DIALOG[@]}" --inputbox "Indique un nuevo nombre" 10 55 2> $output || exit 1
nombre=$(< $output)

mensaje_exito="Renombrada ${DIR_IMAGE##*\/} como $nombre."

[ -n "$nombre" ] && mv $DIR_IMAGE ${DIR_IMAGE%\/*}"/$nombre"
