#!/bin/bash

DIR_BASE=${1%\/}
DIR_IMAGE=${2%\/}
CLASSFILE=$3
TIPO=$4

sintipo="__tipo__"

. $(dirname $0)/functions.sh

output=$(mktemp)
trap "rm -f $output" SIGHUP SIGINT SIGKILL SIGTERM
trap "salida \$? \"\$mensaje_exito\" \"\$mensaje_error\"; rm -f \$output" EXIT

nombre=${DIR_IMAGE##*/}
tipo=${DIR_IMAGE%/*}
tipo=( ${tipo//\// } )
aula=${tipo[0]}
tipo=${tipo[1]}

mensaje_error="No se ha podido cambiar la visibilidad a ${nombre}."

[ -z "$tipo" ] && oldvisi="*" || oldvisi="$tipo"
[ "$aula" = "$sintipo" ] && oldvisi="$oldvisi@*" || oldvisi="$oldvisi@$aula"

[ -n "$tipo" -a -z "$TIPO" ] && exit 2

DIALOG+=( --title "Visibilidad de $nombre ($oldvisi)" )

visibilidad="*"
if [ -n "$TIPO" ]; then
   if [ -z "$tipo" ]; then
      mensaje="La imagen no está asociada a ningún tipo. ¿Desea hacerla exclusiva para el tipo '$TIPO'?"
      "${DIALOG[@]}" --yesno "$mensaje" 8 55
      [ $? -eq 0 ] && res=1 || res=0
   else
      mensaje="La imagen es exclusiva para el tipo $TIPO. ¿Desea hacer la imagen visible para cualquier tipo?"
      "${DIALOG[@]}" --yesno "$mensaje" 8 55
      res=$?
   fi
   if [ $res -eq 0 ]; then
      nuevotipo=""
      visibilidad="*"   
   else
      nuevotipo="$TIPO"
      visibilidad="$TIPO"   
   fi
fi

aulas=()
for a in $DIR_BASE/*/desc; do
   a=${a#$DIR_BASE/}
   a=${a%/desc}
   [ "$aula/$tipo" = "$a/$nuevotipo" ] && continue
   aulas+=( $a )
done

[ ${#aulas[@]} -le 7 ] && max=${#aulas[@]} || max=7
leyenda=( "${aulas[@]}" )
for i in "${!leyenda[@]}"; do
   [ "${leyenda[$i]}" = "$sintipo" ] && leyenda[$i]="Todas" && continue
   leyenda[$i]="${leyenda[$i]} ($(< $DIR_BASE/${aulas[$i]}/desc))"
done

eval '"${DIALOG[@]}"' --notags --menu \"¿Desde qué aula será visible?\" $((8+max)) 50 $max $(for i in ${!leyenda[@]}; do echo $i \"${leyenda[i]}\"; done) 2> $output || exit 1
nuevaaula=${aulas[$(< $output)]}
[ "$nuevaaula" = "__tipo__" ] && visibilidad="$visibilidad@*" || visibilidad="$visibilidad@$nuevaaula"

mensaje_exito="Cambiada la visibilidad de ${nombre} a ${visibilidad}."

mv "$DIR_BASE/$DIR_IMAGE" "$DIR_BASE/$nuevaaula/$nuevotipo/$nombre"

[ -z "$TIPO" ] || borrar_tipo "$DIR_BASE" "${nombre}" "$TIPO" "$CLASSFILE"
