#!/bin/sh

DIR=/home/partimag/$(< /tmp/imagen.txt)
BYTESSECTOR=512

# Hace que todo el grupo encargado de clonaciones
# pueda escribir sobre el directorio
chmod g+w $DIR

# Corrige los problemas de lectura
# cuando se obtenen por NFS las imagenes al clonar
chmod +r $DIR/sd*.xz.*

# Empequeñe el disco para que abarque
# estrictamente las particiones existentes
# (alternativo a usar la opción -icds de clonezilla)

eval $(cat $DIR/sd*-chs.sf)
last_sector=$(awk '/^ +[0-9]/ {print substr($3,1,length($3)-1)}' $DIR/sd*-pt.parted | sort -n | tail -n1)
cylinders=$((last_sector/heads/sectors + 1))

cat > $DIR/sd*-chs.sf <<EOF
cylinders=$cylinders
heads=$heads
sectors=$sectors
EOF

sed -ri '/^Disk/s:[0-9]+s$:'$((cylinders*heads*sectors))'s:' $DIR/sd*-pt.parted

bXs=

MB=$((1024*1024))
GB=$((MB*1024))
TB=$((GB*1024))

unidad=$(sed -r '/^Disk/!d; s:^.*(..)$:\1:; q' $DIR/sd*-pt.parted.compact)
eval size=\$\(\(cylinders*heads*sectors*BYTESSECTOR/$unidad\)\)
sed -ri '/^Disk/s:[0-9]+(..)$:'$size'\1:' $DIR/sd*-pt.parted.compact
