#!/bin/bash

DIR_BASE=${1%\/}
DIR_IMAGE=${2%\/}
CLASSFILE=$3
TIPO=$4

. $(dirname $0)/functions.sh

DIALOG+=( --title "Borrado de ${DIR_IMAGE##*/}" )

[ $# -lt 3 ] && exit 1

mensaje_exito="Eliminada la imagen ${DIR_IMAGE##*/} del servidor."
mensaje_error="Cancelada la eliminacion de ${DIR_IMAGE##*/}"

trap "salida \$? \"\$mensaje_exito\" \"\$mensaje_error\"; rm -f \$output" EXIT

"${DIALOG[@]}" --yesno "Se borrará la imagen definitivamente. ¿Está seguro?" 7 55 || exit 1

rm -fr $DIR_IMAGE

[ -z "$TIPO" ] || borrar_tipo "$DIR_BASE" "${DIR_IMAGE##*/}" "$TIPO" "$CLASSFILE"
