#!/bin/bash

AULA=$1
IMAGEN=$2

. $(dirname $0)/functions.sh

DIALOG+=(--title "Lanzamiento de ${IMAGEN##*/}")

mensaje_exito="Lanzado el multicast para ${IMAGEN##*/}."
mensaje_error="Error en el lanzamiento multicast."

output=$(mktemp)
trap "rm -f $output" SIGHUP SIGINT SIGKILL SIGTERM
trap "salida \$? \"\$mensaje_exito\" \"\$mensaje_error\"; rm -f \$output" EXIT

while true; do
   "${DIALOG[@]}" --inputbox "¿Sobre cuántos clientes se realiza la clonación?" 10 55 2> $output || exit 1
   num=$(< $output)
   [[ $num =~ [0-9]+ ]] && break
   "${DIALOG[@]}" --infobox "Debe escribir un numero entero" 4 40;
   sleep 3
done

while true; do
   "${DIALOG[@]}"  --inputbox "Temporización (en minutos):" 10 55 2> $output || exit 1
   delay=$(< $output)
   [[ $delay =~ [0-9]+ ]] && break
   "${DIALOG[@]}" --infobox "Debe escribir un numero entero" 4 40;
   sleep 3
done

sudo /usr/sbin/dcs -t $((delay*60)) -r $AULA -c $num startdisk $IMAGEN > /dev/null
