<?php

   define("CLASSFILE", "/etc/dhcp/dhcpd.conf.d/classes.conf");
   $dir_nfs="/srv/nfs";
   $dir_images="/images";
   $dir_www = dirname($_SERVER['SCRIPT_NAME']);
   $dir_script = __DIR__;
   $dir_clonezilla="ssoo/clonezilla";
   $dir_tipos = "__tipo__";
   $params="--batch -g auto -e1 auto -e2 -r -j2 -p poweroff";
   $nfs_server=$_SERVER['HTTP_HOST'];
   #boot.php y menu.php consultan el parmetro GET "aula",
   #cuyo valor es de la forma aula/tipo, aunque tipo puede ser "".
   #Las imgenes de clonezilla se buscarn en
   #$dir_images/aula/tipo. Esto sirve para que cada aula tenga
   #sus propias imgenes, y para que dentro de cada aula pueda haber
   #distintos tipos de ordenador, los cuales se identifican a travs
   #de su tarjeta de red. Si es as, en la configuracin de dhcp podr
   # escribirse algo del estilo:
   #class "negros" {
   #   match if binary-to-ascii(16,8,':',substring(hardware,1,3))='de:ad:be';
   #   option tipo = "negros";
   #}
   $aula = split("/",$_GET['aula']);
   $nombreaula=$aula[0];
   $tipo = "clientes sin tipo";
   switch(count($aula)) {
      case 1:
         $aula = array();
         break;
      case 2:
         $ult = array_pop($aula);
         $aula[] = $dir_tipos;
         if ($ult !== "") {
            $aula[] = $aula[0]."/".$ult;
            $aula[] = $dir_tipos."/".$ult;
            $tipo = "clientes '".$ult."'";
            $nombretipo = "$ult";
         }
         break;
      default:
         # Esto es un error...
         $aula = $array();
   }


   #Tipo de servidor: nfs o cifs.
   $server_type='nfs';

   function get_items_cfg() {
      $items = str_replace("##INCLUDE CLONEZILLA##",submenu_clonezilla(),file_get_contents("items.cfg"));
      return str_replace("172.22.0.2",$_SERVER['HTTP_HOST'], $items);
   }

   function get_dir_images($dir_aula) {
      if (!file_exists($dir_aula)) {
         return array();
      }

      foreach(scandir($dir_aula) as $image) {
         $dir_image=$dir_aula."/".$image;
         if ($image=='.' or $image=='..' or !file_exists($dir_image."/disk")) continue;
         $res[]=$image;
      }
      return $res;
   }

   function submenu_clonezilla() {

      global $dir_clonezilla;
      global $nfs_server;
      global $params;
      global $dir_nfs;
      global $dir_script;
      global $dir_images;
      global $aula;
      global $tipo;
      global $server_type;
      global $nombretipo;
      global $nombreaula;
      global $dir_www;
      global $dir_tipos;

      $tmpclonefile = glob("/tmp/*.multicast.clonezilla.php");
      $imagen_multicast = "";
      if(count($tmpclonefile)>0) {
         $imagen_multicast = str_replace("/tmp/", "", $tmpclonefile[0]);
         $imagen_multicast = str_replace(".multicast.clonezilla.php", "", $imagen_multicast);
      }

      $head = "MENU TITLE  Clonezilla (".($nombretipo?$nombretipo:"sin tipo")." en ".$nombreaula.")

LABEL crear
   MENU LABEL ^Crear imagen
   MENU DEFAULT
   KERNEL /ssoo/clonezilla/live/vmlinuz
   APPEND initrd=/ssoo/clonezilla/live/initrd.img boot=live config noswap nolocales edd=on nomodeset noprompt ocs_live_run=\"/tmp/ocs-sr -q2 -j2 -z5 -i 2000 -p true savedisk \" echo_ocs_prerun=\"no\" echo_ocs_postrun=\"no\" ocs_prerun1=\"wget -qO /tmp/script.sh http://$nfs_server$dir_www/script.php?aula=".$_GET['aula']."\" ocs_prerun2=\"sleep 1\" ocs_prerun3=\"chmod +x /tmp/script.sh; /tmp/script.sh || poweroff\" ocs_postrun1=\"wget -qO /tmp/ci.sh http://$nfs_server$dir_www/correct_image.sh; sleep 1\" ocs_postrun2=\"bash /tmp/ci.sh\" ocs_postrun3=\"sleep 1; sudo poweroff\" ocs_live_extra_param=\"\" ocs_live_keymap=\"/usr/share/keymaps/i386/qwerty/es.kmap.gz\" ocs_live_batch=\"no\" ocs_lang=\"es_ES.UTF-8\" vga=788  nosplash fetch=http://".$nfs_server."/boot/ssoo/clonezilla/live/filesystem.squashfs

#       MENU PASSWD 1234
       TEXT HELP
                       Guarda en el servidor con clonezilla
                       y a traves de SSH la imagen de disco.
       ENDTEXT
";
      $res = "";

      foreach($aula as $taula) {
         $dir_aula=$dir_nfs.$dir_images."/".$taula;
         $images=get_dir_images($dir_aula);

         if (file_exists($dir_aula) and count($images)>0) {
            if ($server_type=='cifs')
               $mount="mount -t cifs -o guest //$nfs_server$dir_images/$taula /home/partimag";
            elseif ($server_type=='nfs')
               $mount="mount -t nfs -o ro $nfs_server:$dir_aula /home/partimag";

            $append="initrd=/$dir_clonezilla/live/initrd.img boot=live config noswap nolocales edd=on nomodeset noprompt ocs_live_extra_param=\"\" ocs_live_keymap=\"NONE\" ocs_lang=\"es_ES.UTF-8\" ocs_live_batch=\"yes\" vga=788 nosplash  ocs_prerun=\"$mount\" fetch=http://$nfs_server/boot/$dir_clonezilla/live/filesystem.squashfs ocs_live_run=\"/usr/sbin/ocs-sr $params (IMAGE)\"";
            foreach($images as $image) {
               $dir_image=$dir_aula."/".$image;
               $aula_imagen=explode("/", $taula);
               $leyenda=(count($aula_imagen) == 1?"*":$nombretipo)."@".($aula_imagen[0] == $dir_tipos?"*":$aula_imagen[0]);
               $res=$res."
MENU BEGIN $image
MENU TITLE $image ($leyenda)

LABEL r$image
   MENU LABEL ^Restaurar (unicast)
   KERNEL /$dir_clonezilla/live/vmlinuz
   APPEND ".str_replace("(IMAGE)","restoredisk $image ".trim(file_get_contents($dir_image."/disk")),$append)."
   TEXT HELP
                       Recupera la imagen de disco $image
                       para los ordenadores del aula ".strtoupper($aula[0]).".
   ENDTEXT\n\n";
               if ($imagen_multicast) {
                  if ($imagen_multicast == $image) {
                     include "/tmp/".$image.".multicast.clonezilla.php";
                  $res=$res."
LABEL multicast
   MENU LABEL Restaurar (^multicast)
   KERNEL /$dir_clonezilla/live/vmlinuz
   APPEND ".str_replace("(IMAGE)",$ocs_live_run_params, $append)." ocs_server=".$nfs_server."
   TEXT HELP".$help."ENDTEXT\n\n";
                  }
                  else {
                  $res=$res."

LABEL -
   MENU DISABLE
   MENU LABEL Restaurar (multicast) -- clonando $imagen_multicast";
                  }
               }
               else {
                  $res=$res."
LABEL m$image
   MENU LABEL Lanzar ^multicast
   KERNEL ssoo/slitaz/bzImage
   APPEND initrd=ssoo/slitaz/rootfs.gz lang=es_ES kmap=es rw root=/dev/null vga=normal autologin BOOT_IMAGE=ssoo/slitaz/bzImage netscript='echo -n \"Usuario SSH: \";read U;ssh -t -y \$U@$nfs_server \"$dir_script/lanza_multicast.sh $nombreaula $taula/$image\";echo -en \"Que desea hacer?\\n   [p]oweroff\\n   [r]eboot\\n   [c]ommand line\\n> \";read -n1 -t30 A;case \"\$A\" in r)reboot;;p)poweroff;;*) . /etc/profile;sh;;esac'
   TEXT HELP
                       Lanza la clonacion de la imagen $image.
   ENDTEXT";
               }
               $res=$res." 

MENU SEPARATOR

LABEL b$image
   MENU LABEL Cambiar ^nombre
   KERNEL ssoo/slitaz/bzImage
   APPEND initrd=ssoo/slitaz/rootfs.gz lang=es_ES kmap=es rw root=/dev/null vga=normal autologin BOOT_IMAGE=ssoo/slitaz/bzImage netscript='echo -n \"Usuario SSH: \";read U;ssh -t -y \$U@$nfs_server \"$dir_script/cambia_nombre.sh $dir_image\";echo -en \"Que desea hacer?\\n   [p]oweroff\\n   [r]eboot\\n   [c]ommand line\\n> \" ;read -n1 -t30 A;case \"\$A\" in r)reboot;;p)poweroff;;*) . /etc/profile;sh;;esac'
   TEXT HELP
                       Da un nuevo nombre a la imagen
                       de disco $image.
   ENDTEXT

LABEL b$image
   MENU LABEL Cambiar ^visibilidad
   KERNEL ssoo/slitaz/bzImage
   APPEND initrd=ssoo/slitaz/rootfs.gz lang=es_ES kmap=es rw root=/dev/null vga=normal autologin BOOT_IMAGE=ssoo/slitaz/bzImage netscript='echo -n \"Usuario SSH: \";read U;ssh -t -y \$U@$nfs_server \"$dir_script/cambia_visibilidad.sh $dir_nfs$dir_images $taula/$image ".CLASSFILE." $nombretipo\";echo -en \"Que desea hacer?\\n   [p]oweroff\\n   [r]eboot\\n   [c]ommand line\\n> \" ;read -n1 -t30 A;case \"\$A\" in r)reboot;;p)poweroff;;*) . /etc/profile;sh;;esac'
   TEXT HELP
                       Cambia la visibilidad de la imagen
                       de disco $image.
   ENDTEXT

LABEL b$image
   MENU LABEL ^Eliminar
   KERNEL ssoo/slitaz/bzImage
   APPEND initrd=ssoo/slitaz/rootfs.gz lang=es_ES kmap=es rw root=/dev/null vga=normal autologin BOOT_IMAGE=ssoo/slitaz/bzImage netscript='echo -n \"Usuario SSH: \";read U;ssh -t -y \$U@$nfs_server \"$dir_script/elimina_imagen.sh $dir_nfs$dir_images $dir_image ".CLASSFILE." $nombretipo\";echo -en \"Que desea hacer?\\n   [p]oweroff\\n   [r]eboot\\n   [c]ommand line\\n> \" ;read -n1 -t30 A;case \"\$A\" in r)reboot;;p)poweroff;;*) . /etc/profile;sh;;esac'
   TEXT HELP
                       Elimina del servidor la imagen
                       de disco $image.
   ENDTEXT

MENU SEPARATOR

LABEL -
   MENU LABEL Volver al menu de clonezilla...
   MENU EXIT

MENU END\n\n";
            }
         }
      }
      if ($res !== "" ) {
         $res="
MENU SEPARATOR

LABEL -
   MENU LABEL -- Imagenes --
   MENU INDENT 16
   MENU DISABLE
".$res."

MENU SEPARATOR";
      }

      return $head.$res;
   }
?>
