<?php
   include 'libpxe.php';
   header('Content-type: text/plain');

   for($i=0;$i<count($aula); $i++) {
      $aula[$i] = "$dir_nfs$dir_images/".$aula[$i];
   }

   function nombre_imagen() {
      setlocale(LC_ALL, 'es_ES.UTF-8');
      $nombre=strftime("%B%Y");
      return ucfirst($nombre);
   }

   function clases_existentes() {
      $handle = fopen(CLASSFILE, "r");
      $nombre_clase = array();
      while (($line = fgets($handle)) !== false) {
         if (preg_match("/^\s*class\s+(?:[\"'])([^\"']+)/", $line, $matches)) {
            $nombre_clase[] = $matches[1];
         }
      }
      return join(" ", $nombre_clase);
   }
?>
#!/bin/bash

[ -n "$SSH_ASKPASS_PASSWORD" ] && echo "$SSH_ASKPASS_PASSWORD" && exit 0

DIRS=( <?php echo join(" ",$aula) ?> )
DIR_BASE=<?php echo "$dir_nfs$dir_images/\n";?>
AULA=<?php echo "$nombreaula\n"; ?>
TIPO=<?php echo "$nombretipo\n"; ?>
NFS_SERVER=<?php echo "$nfs_server\n"; ?>
NOMBRE_IMAGEN=<?php echo nombre_imagen(); ?>

DIALOG=(whiptail --backtitle 'Cacharreo Free Software Labs, Rota' --title 'Pre Clonezilla' )

function cancel {
   MENSAJE=${1:-¿Desea cancelar? Se apagará el equipo}
   "${DIALOG[@]}" --defaultno --yesno "$MENSAJE" 7 55 && exit 1
}

function iface() {
   echo "eth0";
}

function ssh_askpass() {
    read SSH_ASKPASS_PASSWORD

    export SSH_ASKPASS=$0
    export SSH_ASKPASS_PASSWORD

    [ "$DISPLAY" ] || export DISPLAY=dummydisplay:0

    # use setsid to detach from tty
    setsid "$@" </dev/null
}

PREGUNTA_TIPO=0
if [ -z "$TIPO" ]; then
   TIPOS_PRE="<?php echo clases_existentes(); ?>";
   while true; do
      "${DIALOG[@]}" --inputbox "Se ha detectado un nuevo tipo de ordenador. Introduzca su nombre (o déjelo vacío si no quiere crear ningún tipo)" 10 50 2>/tmp/tipo.txt
      test -f /tmp/tipo.txt && TIPO=$(</tmp/tipo.txt)
      if [ -z "$TIPO" ]; then
         rm -f /tmp/tipo.txt
      else
         if [ "${TIPO}" != "${TIPO/ /}" ]; then
            "${DIALOG[@]}" --msgbox "El nombre no puede contener espacios. Inténtelo de nuevo." 7 45
            continue
         fi
         if grep -qP '\b'"$TIPO"'\b' <<<"$TIPOS_PRE"; then
            "${DIALOG[@]}" --msgbox "Ya hay definido un tipo con ese nombre. Inténtelo de nuevo." 7 45
            continue
         fi
         "${DIALOG[@]}" --inputbox "Escriba una breve descripción para el tipo" 8 50 "Ordenadores $TIPO" 2>/tmp/desc.txt
         DIRS+=( ${DIRS[0]}/$TIPO ${DIR_BASE}<?php echo $dir_tipos; ?>/$TIPO )
         PREGUNTA_TIPO=1
      fi
      break
   done
fi

VISI=( "Para cualquier cliente en $AULA [*@$AULA]" "Para cualquier cliente en cualquier aula [*@*]" )
if [ -n "$TIPO" ]; then
   VISI+=( "Exclusiva para clientes $TIPO en $AULA [$TIPO@$AULA]" "Exclusiva para clientes $TIPO en cualquier aula [$TIPO@*]" )
fi

DIRS+=( "Otra ubicacion..." )
VISI+=( "Elija una ubicación manualmente..." )

while true; do
   while true; do
      "${DIALOG[@]}" --inputbox 'Usuario con acceso SSH' 8 35 "$USUARIO" 2>/tmp/usuario.txt
      if [ $? -eq 0 ]; then
         USUARIO=$(< /tmp/usuario.txt)
         [ -n "$USUARIO" ] || continue
         break
      fi
      cancel
   done

   tmpfile=$(mktemp)
   while true; do
      "${DIALOG[@]}" --passwordbox 'Contraseña' 8 35 2>$tmpfile && break
       cancel
   done
   PASS=$(< $tmpfile)
   rm -f $tmpfile

   if [ $PREGUNTA_TIPO -eq 1 ]; then
      "${DIALOG[@]}" --infobox "Creando el tipo en el servidor..." 7 45
      ini=$(date +%s)
      mac=$(< /sys/class/net/`iface`/address)
      echo "$PASS" | ssh_askpass ssh -o StrictHostKeyChecking=no "$USUARIO"@$NFS_SERVER "/srv/tftp/pxelinux.cfg/define_tipo.sh $TIPO $mac $DIR_BASE <?php echo CLASSFILE; ?> $(< /tmp/desc.txt)"
      RESP=$?
      fin=$(date +%s)
      esp=$((4+ini-fin))
      [ $esp -le 0 ] || sleep $esp
      if [ $RESP -ne 0 ]; then
         cancel "Imposible crear el tipo. ¿Desea salir?"
         continue
      fi
   fi

   while true; do
      eval '"${DIALOG[@]}"' --notags --menu \"Visibilidad de la imagen\" $((8+${#DIRS[@]})) 75 ${#DIRS[@]} $(for i in ${!VISI[@]}; do echo $i \"${VISI[$i]}\"; done) 2> /tmp/dremoto.txt
      if [ $? -eq 0 ]; then
         DREMOTO=$(< /tmp/dremoto.txt)
         if [ $((DREMOTO+1)) -eq ${#DIRS[@]} ]; then
            "${DIALOG[@]}" --inputbox 'Almacen remoto' 8 45  "$DIR_BASE" 2>/tmp/dremoto.txt
            if [ $? -eq 0 ]; then
               DREMOTO=$(< /tmp/dremoto.txt)
               break
            fi
            cancel   
         else
            DREMOTO=${DIRS[$DREMOTO]}
            break
         fi
      else
         cancel
      fi
   done

   echo "$PASS" | sshfs -o StrictHostKeyChecking=no,password_stdin $USUARIO@$NFS_SERVER:$DREMOTO /home/partimag && break

   cancel "Imposible montar el directorio remoto. ¿Desea salir?"
done

while true; do
   "${DIALOG[@]}" --inputbox 'Nombre de la imagen' 8 45  "$NOMBRE_IMAGEN" 2>/tmp/imagen.txt && break
   cancel
done

cat>/tmp/ocs-sr <<"EOF"
#!/bin/bash

ocs-sr "$@" $(< /tmp/imagen.txt) ask_user
EOF

chmod +x /tmp/ocs-sr
